"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const types_1 = require("../../types");
const common_1 = require("./common");
const wethToEth_1 = require("../../utils/wethToEth");
const getHttpUrl = (options) => {
    const base = wethToEth_1.wethToEth(options.base);
    const quote = wethToEth_1.wethToEth(options.quote);
    switch (options.network) {
        case types_1.Network.MAINNET:
            return `https://api.ethfinex.com/v2/book/t${base}${quote}/R0`;
        case types_1.Network.KOVAN:
            return `https://kovan.api.ethfinex.com/v2/book/t${base}${quote}/R0`;
        default:
            throw new Error('Invalid network.');
    }
};
exports.fetch = (options) => __awaiter(this, void 0, void 0, function* () {
    const { data } = yield axios_1.default.get(getHttpUrl(options));
    return data.map((order) => {
        const id = common_1.orderId(order);
        return common_1.normalizeOrder(options, order, id);
    });
});
