"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("../common");
const types_1 = require("../../../types");
exports.add = (trade, auth) => __awaiter(this, void 0, void 0, function* () {
    const base = trade.base;
    const quote = trade.quote;
    const params = Object.assign({ pair: `${base}${quote}`, type: trade.side.toLowerCase(), ordertype: trade.type.toLowerCase(), volume: trade.volume }, (trade.type === types_1.OrderType.LIMIT && {
        price: trade.price,
    }));
    const response = (yield common_1.privateRequest('AddOrder', params, auth)).data;
    if (response.error && !!response.error.length) {
        throw new Error(response.error);
    }
    return response.result;
});
