"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Rx = __importStar(require("rxjs"));
const fetch_1 = require("./fetch");
const types_1 = require("../../types");
const operators_1 = require("rxjs/operators");
const cleanEvents_1 = require("../../utils/cleanEvents");
const debug = __importStar(require("../../debug"));
const createSnapshot = (options, orders) => ({
    event: types_1.NormalizedMessageType.SNAPSHOT,
    exchange: types_1.Exchange.OASIS_DEX,
    network: options.network,
    base: options.base,
    quote: options.quote,
    orders,
});
// TODO: Listen to on-chain events instead of polling.
exports.watch = (options) => {
    const interval = options.interval || 5000;
    const orders$ = Rx.timer(0, interval).pipe(operators_1.retryWhen(error => error.pipe(operators_1.delay(10000))), operators_1.exhaustMap(() => fetch_1.fetch(options)));
    return orders$.pipe(operators_1.map(orders => createSnapshot(options, orders)), operators_1.tap(event => debug.log('Source event: %e', event)), cleanEvents_1.cleanEvents(), operators_1.tap(event => debug.log('Output event: %e', event)));
};
